unit lbdemou;

interface

uses
{$ifdef Win32}
  Windows,
{$else}
  WinProcs, WinTypes,
{$endif}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, LoopBtn, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ImageFox: TImage;
    ImageRabbit: TImage;
    LoopButton1: TLoopButton;
    ButtonReset: TButton;
    LabelFox: TLabel;
    LoopButton2: TLoopButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    MemoHelp: TMemo;
    ButtonExit: TButton;
    LabelRabbit: TLabel;
    LabelExcept: TLabel;
    MemoReadme: TMemo;
    BitBtnReadme: TBitBtn;
    BitBtnAbout: TBitBtn;
    procedure LoopButton1Click(Sender: TObject);
    procedure ButtonResetClick(Sender: TObject);
    procedure LoopButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoopButton2IterEvent(Sender: TObject; IterState: TIterState);
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonReadmeClick(Sender: TObject);
    procedure LoopButton1IterEvent(Sender: TObject; IterState: TIterState);
    procedure BitBtnAboutClick(Sender: TObject);
  private
    { Private declarations }
    PictureText1: string;
    LabelRabbitPos: Integer;
    LabelFoxPos: Integer;
    ImFoxH: Integer;
    ImFoxW: Integer;
    ImFoxT: Integer;
    ImFoxL: Integer;
    ReadmeOn: Boolean;
    procedure ChangeReadmeState;
    procedure DrawLines(Col: TColor);
    procedure Reset1;
    procedure Reset2;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses About;

var SearchRec: TSearchRec;
    ScanContinue: Boolean;
    Path: string;

function Meeting(X: Integer): Boolean;
begin
with Form1.ImageRabbit do
  Result:=((Left + Width - 3)  > X);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
PictureText1:=LabelFox.Caption;
LabelRabbitPos:=LabelRabbit.Left;
LabelFoxPos:=LabelFox.Left;
with ImageFox do begin
  ImFoxH:=Height;  ImFoxW:=Width;
  ImFoxT:=Top;  ImFoxL:=Left;
  end;
ReadmeOn:=False;
ChangeReadmeState;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.ButtonResetClick(Sender: TObject);
begin
{ sample 1: }
LoopButton1.Stop; 
LoopButton1.Reset; 
Reset1;
{ sample 2: }
LoopButton2.Stop; 
LoopButton2.Reset; 
Reset2;
end;

procedure TForm1.Reset1; { sample 1 }
begin
with ImageRabbit do begin
  Left:=5;
  Visible:=True;
  end;
with ImageFox do begin
  Stretch:=False;
  Align:=alNone;
  Height:=ImFoxH;  Width:=ImFoxW;
  Top:=ImFoxT;  Left:=ImFoxL;
  end;
with LabelExcept do begin
  SendToBack;
  Visible:=False;
  end;
LabelFox.Caption:=PictureText1;
LabelFox.Left:=LabelFoxPos;
LabelRabbit.Left:=LabelRabbitPos;
LabelRabbit.Visible:=True;
end;

procedure TForm1.Reset2; { sample 2 }
begin
if ScanContinue then begin
  FindClose(SearchRec);
  ScanContinue:=False;
  end;
Edit1.Text:='';
Memo1.Lines.Clear;
end;

procedure TForm1.LoopButton1Click(Sender: TObject);
begin
if Meeting(ImageFox.Left) then begin
    ImageRabbit.Visible:=False;
    with LabelFox do begin
       Left:=Panel1.Left + (Panel1.Width - Width) div 2;
       Caption:='End of story, see step count on LoopButton';
       end;
    with LabelExcept do begin
      BringToFront;
      Visible:=True;
      end;
    with ImageFox do begin
      Stretch:=True;
      Align:=alClient;
      SendToBack;
      end;
    LabelRabbit.Visible:=False;
    LoopButton1.Stop;  
    end  { Meeting }
else begin
    ImageRabbit.Left:=ImageRabbit.Left + 20;
    LabelRabbit.Left:=LabelRabbit.Left + 20;
    end;
end;

procedure TForm1.LoopButton1IterEvent(Sender: TObject;
  IterState: TIterState);
begin
case IterState of
  stLoopStart: Reset1;
  end;
end;

procedure TForm1.LoopButton2Click(Sender: TObject);
var Done: Integer;
    S: array [0..200] of char;
begin
if ScanContinue then
  Done:=FindNext(SearchRec)
else begin
  GetWindowsDirectory(S,200);
  Path:=StrPas(S);
  if Path[StrLen(S)] <> '\' then Path := Path + '\';
  Done:=FindFirst(Path+'*.ini', faAnyFile, SearchRec);
  ScanContinue:=True;
  end;
if Done = 0 then begin
  Edit1.Text:=Path + SearchRec.Name;
  Memo1.Lines.LoadFromFile(Edit1.Text);
  end
else begin
  Edit1.Text:='';
  Memo1.Lines.Clear;
  FindClose(SearchRec);
  ScanContinue:=False;
  LoopButton2.Stop;
  end;
end;

procedure TForm1.LoopButton2IterEvent(Sender: TObject;
  IterState: TIterState);
begin
case IterState of
  stLoopStart: Reset2;
  end;
end;

{ ----------------- README ----------------}
procedure TForm1.DrawLines(Col: TColor);
begin
with Canvas do begin
  Pen.Color:=Col;
  MoveTo(MemoReadme.Left,MemoReadme.Top);
  LineTo(LoopButton1.Left+LoopButton1.Width,LoopButton1.Top);
  MoveTo(MemoReadme.Left,MemoReadme.Top);
  LineTo(LoopButton2.Left+LoopButton1.Width,LoopButton2.Top);
  end;
end;

procedure TForm1.ChangeReadmeState;
begin
if ReadmeOn then begin
  MemoReadme.Visible:=True;
  BitBtnReadme.Caption:='Hide text';
  DrawLines(clRed);
  end
else begin
  MemoReadme.Visible:=False;
  BitBtnReadme.Caption:='Explain';
  DrawLines(Color);  { i.e. Form.Color, clBtnFace }
  end
end;

procedure TForm1.ButtonReadmeClick(Sender: TObject);
begin
ReadmeOn := not ReadmeOn;
ChangeReadmeState;
end;

procedure TForm1.BitBtnAboutClick(Sender: TObject);
begin
AboutBox.ShowModal;
end;

initialization
ScanContinue:=False;

end.
